
{$APPTYPE GUI}{$MODE DELPHI}

program demo37;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_Model,GOGL_Collision;

//const
 
//type
  
var 
  i,l,m:integer;
  pos:array[0..14,0..14]of TGLVector;
  rot,size:array[0..14,0..14]of glfloat;  
  vert:array[0..50]of TGLVertex3f;
  r0:array[0..10]of TGLFindVertex3f;
  MaxVert:integer;
  cnt,time:glfloat;  
  mdl:TGLMD3Model; 
  player:TGLVector;
  
   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(3,3, 0,3, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 3,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


function GenWind(dir:TGLVector;ang,min,max,windspeed,time:glfloat):TGLVector;
var
  factor:glfloat;	
begin
  if(factor>0)then factor:=max;
  if(factor<0)then factor:=min;
		
  result.x:=sin(time)*random*factor+sin(time)*windspeed+dir.x;	 
  result.y:=sin(ang+time)*random*factor+sin(ang+time)*windspeed+dir.y;
  result.z:=sin(time)*random*factor+sin(time)*windspeed+dir.z;  
end;


function RepulsionAngle(pos1,pos2:TGLVector):TGLVector;
begin
  result.y:=-GetTargetPoint2f(pos1.x,pos1.z,pos2.x,pos2.z);
  result.z:=VecLength(pos1,pos2);
end;


procedure Pianta(v:TGLVertex3f;pos:TGLVector;ang,size,ry,time:glfloat);
var 
  i:integer;
  wind:TGLVector;
  angle:TGLVector;
  
begin 
  wind:=GenWind(glvector(0,5,-4),ang, 0,5, 2.5, time); // crea il vento
  angle:=RepulsionAngle(player,pos); // crea le rotazioni 
  
  MaxVert:=848*9;      
  glSetMaxVertex3f(v,MaxVert);   

  // manipolazione dei vertici
  if SphereInsideSphere(player,pos, 1,1.5)then
  begin
    for i:=1 to 5 do glRotateVertex3f(v,r0[i],0,0,0, 0,angle.z*i*1.5-wind.z*i,angle.y+wind.y*i, MaxVert);
    glRotateVertex3f(v,r0[6],0,0,0, 0,angle.z*6*1.5-wind.z*6,angle.y+wind.y*6, MaxVert);
  end else
  begin	
    for i:=1 to 5 do glRotateVertex3f(v,r0[i],0,0,0, 0,wind.z*i,wind.y*i, MaxVert);
    glRotateVertex3f(v,r0[6],0,0,0, 0,wind.z*6,wind.y*6, MaxVert);  
  end;
  
  //TwoSideON;
  SetglSprite;
  glDisable(GL_CULL_FACE);
  
  glPushMatrix;
  glTranslatef(pos.x,pos.y,pos.z);    
  glScalef(0.5,0.5,0.5);
  glRotatef(90,0,-1,0);
  glRotatef(90,-1,0,0);    
  mdl.PutModel;
  glPopMatrix;
	
  glEnable(GL_CULL_FACE);
  SetglSpriteOFF;
  //TwoSideOFF;  
  
  // Impostazione aree per il rilevamento dei vertici
  for i:=1 to 5 do glCheckRotateV3f(r0[i],glvector(0,0,2.9*i), glvector(-5,-5,-1.2),glvector(5,5,1.2),MaxVert);  
  glCheckRotateV3f(r0[6],glvector(0,0,2.9*6), glvector(-5,-5,-1.8),glvector(5,5,1.2),MaxVert); 
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('Floor07.bmp',0);
  TextureLoadTGAID('pianta00.tga',0);
  
end;
begin 

  OpenGL_Texture();
  
  mdl.LoadModel('pianta00.md3');  
  
  for l:=0 to 3 do for m:=0 to 2 do
  begin
    pos[l,m]:=glvector(7-random(14),0,7-random(14));
    rot[l,m]:=180-random(360);
  end;
  
  player:=glvector(0,0.5,6);
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
  if SetglKey('W')then player.z:=player.z-0.25;
  if SetglKey('S')then player.z:=player.z+0.25;  
  if SetglKey('A')then player.x:=player.x-0.25; 
  if SetglKey('D')then player.x:=player.x+0.25;   
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(45,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, 0,10,5, 0.1); 
  
  time:=(GetTickCount/500);
  
  TextureSelectID(0);   
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10);  
  
  VertexEditON;  
  
  TextureTGASelectID(0);  
  for l:=0 to 3 do for m:=0 to 2 do
  Pianta(vert[0],pos[l,m],rot[l,m], 1,0, time);
 
  VertexEditOFF;
 
  // giocatore
  TextureOFF;
  Sfera(player.x,player.y,player.z, 1,32,32, 1);    
  TextureON;
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Piante con movimento generato tramite manipolazione dei vertici', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
